                PAGE    ,132
                TITLE   COPYFILE.ASM -- copy file
                %OUT    COPYFILE.ASM
                .XALL
INCL_CONSOLE    EQU     0    
INCL_FILE       EQU     0    
INCL_PROCESS    EQU     0    
                INCLUDE CONSTANT.INC
                INCLUDE DosCalls.MAC
                INCLUDE EnvArgs.INC

BUFFERSIZE      EQU     512

myStack         SEGMENT PARA STACK
                DB      128 DUP("@")
myStack         ENDS

myData          SEGMENT PARA
buffer          DB      BUFFERSIZE DUP('$')
inHandle        DW      0
inFile          DB      MAXLINE DUP('$')
inMode          DB      0       ; Read
inChars         DW      BUFFERSIZE
outHandle       DW      0
outFile         DB      MAXLINE DUP('$')
outMode         DB      1       ; Write
outAttrib       DW      0
outChars        DW      BUFFERSIZE
argc            DW      0
timestamp       DW      0       ; year
                DB      0       ; month
                DB      0       ; day
                DB      0       ; hour
                DB      0       ; minute
                DB      0       ; second
rc              DB      0
errMsg1         DB      "g: copyfile Rs[t@C Rs[t@C", CRCHAR, LFCHAR, '$'
errMsg2         DB      "Rs[t@C܂B", CRCHAR, LFCHAR, '$'
errMsg3         DB      "Rs[t@C܂BRs[Ƃ𒆎~܂B", CRCHAR, LFCHAR, '$'
errMsg4         DB      "߂܂łBRs[Ƃ𒆎~܂B", CRCHAR, LFCHAR, '$'
myData          ENDS

myTest          SEGMENT PARA
                ASSUME  CS:myTest, DS:myData, ES:myData, SS:myStack
main            PROC
                MOV     AX, SEG myData  ; setup DS
                MOV     DS, AX

                @getArgc argc
                CMP     argc, 2
                JE      main2
                @DosDispString errMsg1
                JMP     main6
                
main2:          
                MOV     argc, 1
                @getArgv argc inFile
                
                MOV     argc, 2
                @getArgv argc outFile

                @DosOpen inFile inMode inHandle  
                JNC      main3
                @DosDispString errMsg2
                @DosClose inHandle
                MOV     rc, 0FFH
                JMP     main6

main3:
                @DosOpen outFile inMode outHandle
                JC      main4                                                                                                                                                                                                                                
                @DosDispString errMsg3
                @DosClose inHandle
                @DosClose outHandle
                MOV     rc, 0FFH
                JMP     main6
                
main4:
                @DosCreat outFile outAttrib outHandle
                
main5:
                MOV     inChars, BUFFERSIZE
                @DosRead inHandle buffer inChars
                CMP     inChars, 0
                JE      main6
                MOV     AX, inChars
                MOV     outChars, AX
                @DosWrite outHandle buffer outChars
                MOV     AX, outChars
                CMP     AX, inChars
                JE      main5
                @DosDispString errMsg4
                @DosClose inHandle
                @DosClose outHandle
                MOV     rc, 0FFH
                JMP     main7
main6:                
                @DosGetTimeStamp inHandle timestamp
                @DosSetTimeStamp outHandle timestamp
                @DosClose inHandle
                @DosClose outHandle
main7:                
                @DosExit rc
main            ENDP
myTest          ENDS
                END     main
