                PAGE    ,132
                TITLE   TYPEOUT.ASM -- Type out file
                %OUT    TYPEOUT.ASM
                .XALL
INCL_CONSOLE    EQU     0    
INCL_FILE       EQU     0    
INCL_PROCESS    EQU     0    
                INCLUDE CONSTANT.INC
                INCLUDE DosCalls.MAC
                INCLUDE ENVARGS.INC
                
MAXLINES        EQU     24
BUFFERSIZE      EQU     512

myStack         SEGMENT PARA STACK
                DB      128 DUP("@")
myStack         ENDS

myData          SEGMENT PARA
fBuffer         DB      BUFFERSIZE DUP('%')
chars           DW      BUFFERSIZE
fp              DW      BUFFERSIZE
fEOF            DB      NOT EOF
inHandle        DW      0

lBuffer         DB      MAXLINE DUP('#')
lp              DW      0
lBase           DW      OFFSET lBuffer

outChars        DW      0
outHandle       DW      stdout

lines           DW      0
argc            DB      0
argIndex        DB      0
fileName        DB      128 DUP('#')
fileMode        DB      0

junk            DB      '$'

usage           DB      "g: typeout t@C", CRCHAR, LFCHAR, '$'
fileError       DB      "t@C܂B", CRCHAR, LFCHAR, '$' 

rc              DB      0
myData          ENDS

typeOut         SEGMENT PARA
                ASSUME  CS:typeOut, DS:myData, ES:myData, SS:myStack

getc            PROC    NEAR
                MOV     AX, fp
                CMP     AX, chars
                JNE     getc2
                @DosRead inHandle, fBuffer, chars
                CMP     chars, 0
                JE      getc1
                MOV     fp, 0
getc2:                
                MOV     BP, OFFSET fBuffer
                MOV     SI, [fp]
                MOV     AL, DS:BYTE PTR DS:[BP+SI]

                CMP     AL, EOFCHAR
                JNE     getc3
                MOV     fEOF, EOF
getc3:                
                INC     fp
                RET
getc1: 
                MOV     AL, EOS
                MOV     fEOF, EOF
                RET
getc            ENDP

readLine        PROC    NEAR
readLine2:
                CALL    getc
                CMP     fEOF, EOF
                JE      readLine4
                CMP     AL, EOFCHAR
                JE      readLine4
                CMP     AL, CRCHAR
                JNE     readLine3
                CALL    getc
                CMP     AL, LFCHAR
                JE      readLine4
readLine3:                
                MOV     BP, OFFSET lBuffer
                MOV     SI, lp
                MOV     BYTE PTR DS:[BP+SI], AL
                INC     lp
                JMP     readline2
readLine4:         
                MOV     BP, OFFSET lBuffer
                MOV     SI, lp
                MOV     BYTE PTR DS:[BP+SI], EOS
                MOV     lp, 0
                RET
readLine        ENDP

writeLine       PROC    NEAR
                MOV     BP, OFFSET lBuffer
                CALL    slength
                MOV     BYTE PTR DS:[BP+SI], CRCHAR
                INC     SI
                MOV     BYTE PTR DS:[BP+SI], LFCHAR
                INC     SI
                MOV     outChars, SI
                @DosWrite outHandle lBuffer outChars
                RET
writeLine       ENDP

slength         PROC    NEAR
                MOV     SI, 0
slenght2:        
                CMP     BYTE PTR DS:[BP+SI], EOS
                JE      slenght1
                INC     SI
                JMP     slenght2
slenght1:        
                RET
slength         ENDP

pause           PROC    NEAR
                @DosConInClear junk
                RET
pause           ENDP

main            PROC
                MOV     AX, SEG myData  ; setup DS
                MOV     DS, AX

                @getArgc argc
                CMP     argc, 1
                JGE     main6
                @DosDispString usage
                JMP     main3
                
main6:
                MOV     argIndex, 1
                @getArgv argIndex fileName

                @DosOpen fileName fileMode inHandle
                JNC     main5
                @DosDispString fileError
                JMP     main3
                
main5:
                MOV     lines, 0
main1:
                CMP     lines, MAXLINES
                JNE     main7
                CALL    pause
                MOV     lines, 0
main7:                
                CALL    readLine
                CMP     fEOF, EOF
                JE      main4
                CALL    writeLine
                INC     lines
                JMP     main1
main4:
                @DosClose inHandle
                JMP     main3
                
main3:
                MOV     rc, 00H
                @DosExit rc
main            ENDP
typeOut         ENDS
                END     main
