                PAGE    ,132
                TITLE   XCHDIR.ASM -- Change drive and directory
                %OUT    XCHDIR.ASM
                .XALL
INCL_DIR        EQU     0
INCL_DISK       EQU     0
INCL_CONSOLE    EQU     0
INCL_PROCESS    EQU     0    
                INCLUDE CONSTANT.INC
                INCLUDE DosCalls.MAC
                INCLUDE EnvArgs.INC
               
myStack         SEGMENT PARA STACK
                DB      128 DUP("@")
myStack         ENDS

MAXDIR          EQU     128

myData          SEGMENT PARA
argc            DW      0
directory       DB      MAXDIR DUP('%'), EOS
drive           DB      'C'
rc              DB      0FFH
errMsg1         DB      'g: xchdir fBNg[', CRCHAR, LFCHAR, '$'
errMsg2         DB      'hCu^[słB', CRCHAR, LFCHAR, '$'
errMsg3         DB      'fBNg[słB', CRCHAR, LFCHAR, '$'
myData          ENDS

xchdirCode      SEGMENT PARA
                ASSUME  CS:xchdirCode, DS:myData, ES:myData, SS:myStack

main            PROC
                MOV     AX, SEG myData  ; setup DS
                MOV     DS, AX

                @getArgc argc
                CMP     argc, 1
                JE      main1
                @DosDispString errMsg1
                JMP     main0
main1:          
                @getArgv argc directory
                MOV     SI, OFFSET directory
                CMP     BYTE PTR [SI+1], ':'
                JNE     main2
                MOV     AL, BYTE PTR [SI]
                MOV     drive, AL
                @DosCurDisk drive
                JNC     main2
                @DosDispString errMsg2
                JMP     main0
main2:
                @DosChdir directory
                JNC     main0
                @DosDispString errMsg3
                
main0:          
                MOV     rc, 00H
                @DosExit rc
main            ENDP
xchdirCode      ENDS
                END     main
